#include <artsflow.h>
#include <soundserver.h>
#include <debug.h>
#include <stdio.h>
#include <connect.h>
#include "jmcopsync.h"

int main()
{
	Arts::Dispatcher dispatcher;

	Arts::SoundServer server = Arts::Reference("global:Arts_SoundServer");
	if(server.isNull())
		arts_fatal("couldn't connect artsd");

	Arts::Synth_AMAN_PLAY play;
	Arts::Synth_WAVE_SIN sin1, sin2;
	Arts::Synth_FREQUENCY freq1, freq2;
	JMCOPSync sync;

	play = Arts::DynamicCast(server.createObject("Arts::Synth_AMAN_PLAY"));
	if(play.isNull())
		arts_fatal("can't create Arts::Synth_AMAN_PLAY on server");

	sin1 = Arts::DynamicCast(server.createObject("Arts::Synth_WAVE_SIN"));
	if(sin1.isNull())
		arts_fatal("can't create Arts::Synth_WAVE_SIN on server");
		
	sin2 = Arts::DynamicCast(server.createObject("Arts::Synth_WAVE_SIN"));
	if(sin2.isNull())
		arts_fatal("can't create Arts::Synth_WAVE_SIN on server");
		
	freq1 = Arts::DynamicCast(server.createObject("Arts::Synth_FREQUENCY"));
	if(freq1.isNull())
		arts_fatal("can't create Arts::Synth_FREQUENCY on server");
		
	freq2 = Arts::DynamicCast(server.createObject("Arts::Synth_FREQUENCY"));
	if(freq2.isNull())
		arts_fatal("can't create Arts::Synth_FREQUENCY on server");
		
	sync = Arts::DynamicCast(server.createObject("JMCOPSync"));
	if(sync.isNull())
		arts_fatal("can't create JMCOPSync on server");
	
	setValue(freq1, 440);
	setValue(freq2, 880);
	connect(freq1, sin1);
	connect(freq2, sin2);
	connect(sin1, play, "left");
	connect(sin2, play, "right");

	// start all objects at once
	sync.queueStart(freq1);
	sync.queueStart(freq2);
	sync.queueStart(sin1);
	sync.queueStart(sin2);
	sync.queueStart(play);
	sync.execute();

	printf("  << type return key to stop >> \n");
	getchar();

	// stop all objects at once
	sync.queueStop(freq1);
	sync.queueStop(freq2);
	sync.queueStop(sin1);
	sync.queueStop(sin2);
	sync.queueStop(play);
	sync.execute();
}
